#include	<p18cxxx.h>
#include	"Regeltrafo.h"

#pragma code low_vector=0x18
void interrupt_at_low_vector(void)
{
	_asm goto isr _endasm
}
#pragma code


#pragma code high_vector=0x08
void interrupt_at_high_vector(void){
    _asm goto isr _endasm
}
#pragma code


#pragma interrupt isr
void isr (void) {															// INTERRUPT SERVICE ROUTINE

	extern unsigned char trigger;

	if (INTCONbits.TMR0IF) {												// TMR0
		INTCONbits.TMR0IF = 0x0;											// clear TMR0 interrupt flag
		TMR0H = 0xF5;														// preset TMR0 to 65535 - (2.000.000 / 256 / 3) => overflow every 1/3 sec.
		TMR0L = 0xD4;
	
		trigger = 0x1;
	}

	if (PIR2bits.TMR3IF) {													// TMR3
		T3CONbits.TMR3ON = 0x0;												// stop timer3
		TMR3H = 0x0;														// reset timer3
		TMR3L = 0x0;
		PIE2bits.TMR3IE = 0x0;												// disable timer3 interrupts
	 	PIR2bits.TMR3IF = 0x0;												// clear timer3 interrupt flag
	}
}


void TMR0_Init (void) {														// Init timer0

	INTCONbits.TMR0IF = 0x0;												// clear TMR0 interrupt flag
	TMR0H = 0xF5;															// preset TMR0 to 65535 - (2.000.000 / 256 / 3) => overflow every 1/3 sec.
	TMR0L = 0xD4;
	T0CONbits.TMR0ON = 0x1;													// start TMR0
}


void TMR3_Init (unsigned char msec) {										// Init timer3 with msec milliseconds (max. 254)

	TMR3H = 0xFF - msec+1;													// preset TMR3
	TMR3L = 0x1;
 	PIR2bits.TMR3IF = 0x0;													// clear timer3 interrupt flag
	PIE2bits.TMR3IE = 0x1;													// enable timer3 interrupts
	T3CONbits.TMR3ON = 0x1;													// start timer3
}

